<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cy__ble__ndcs_8h" kind="file" language="C++">
    <compoundname>cy_ble_ndcs.h</compoundname>
    <includes local="yes" refid="cy__ble_8h">cy_ble.h</includes>
    <includedby local="yes" refid="cy__ble__event__handler_8h">cy_ble_event_handler.h</includedby>
    <innerclass prot="public" refid="structcy__stc__ble__ndcs__char__value__t">cy_stc_ble_ndcs_char_value_t</innerclass>
    <innerclass prot="public" refid="structcy__stc__ble__ndcss__t">cy_stc_ble_ndcss_t</innerclass>
    <innerclass prot="public" refid="structcy__stc__ble__ndcsc__t">cy_stc_ble_ndcsc_t</innerclass>
    <innerclass prot="public" refid="structcy__stc__ble__ndcss__config__t">cy_stc_ble_ndcss_config_t</innerclass>
    <innerclass prot="public" refid="structcy__stc__ble__ndcsc__config__t">cy_stc_ble_ndcsc_config_t</innerclass>
      <sectiondef kind="enum">
      <memberdef id="group__group__ble__service__api___n_d_c_s__definitions_1ga45eb82d743c04984f5db34e967541862" kind="enum" prot="public" static="no">
        <name>cy_en_ble_ndcs_char_index_t</name>
        <enumvalue id="group__group__ble__service__api___n_d_c_s__definitions_1gga45eb82d743c04984f5db34e967541862a2e0f3f530c62ea801c2faccecfbe7999" prot="public">
          <name>CY_BLE_NDCS_TIME_WITH_DST</name>
          <briefdescription>
<para>Time with DST Characteristic index. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__ble__service__api___n_d_c_s__definitions_1gga45eb82d743c04984f5db34e967541862a72ef1aa6d2418640c05122448829b333" prot="public">
          <name>CY_BLE_NDCS_CHAR_COUNT</name>
          <briefdescription>
<para>Total Count of NDCS Characteristics. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cy_en_ble_ndcs_char_index_t: </bold><linebreak />Characteristic indexes.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="43" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.h" bodystart="39" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.h" line="40" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="var">
      <memberdef id="cy__ble__ndcs_8h_1a411be77e8eec39d4ce5c93d4be1f57a0" kind="variable" mutable="no" prot="public" static="no">
        <type>const <ref kindref="compound" refid="structcy__stc__ble__ndcss__config__t">cy_stc_ble_ndcss_config_t</ref> *</type>
        <definition>const cy_stc_ble_ndcss_config_t* cy_ble_ndcssConfigPtr</definition>
        <argsstring />
        <name>cy_ble_ndcssConfigPtr</name>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.c" bodystart="45" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.h" line="129" />
      </memberdef>
      <memberdef id="cy__ble__ndcs_8h_1ab7c7f464a8c42a48c92226f88dee315c" kind="variable" mutable="no" prot="public" static="no">
        <type>const <ref kindref="compound" refid="structcy__stc__ble__ndcsc__config__t">cy_stc_ble_ndcsc_config_t</ref> *</type>
        <definition>const cy_stc_ble_ndcsc_config_t* cy_ble_ndcscConfigPtr</definition>
        <argsstring />
        <name>cy_ble_ndcscConfigPtr</name>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.c" bodystart="48" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.h" line="130" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__ble__service__api___n_d_c_s__server__client_1ga88bcea3051b51b6ce572807f1d90605d" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__ble__common__api__definitions_1ga63f6be7f53f5ad7d82c394e4cdfa619e">cy_en_ble_api_result_t</ref></type>
        <definition>cy_en_ble_api_result_t Cy_BLE_NDCSS_Init</definition>
        <argsstring>(const cy_stc_ble_ndcss_config_t *config)</argsstring>
        <name>Cy_BLE_NDCSS_Init</name>
        <param>
          <type>const <ref kindref="compound" refid="structcy__stc__ble__ndcss__config__t">cy_stc_ble_ndcss_config_t</ref> *</type>
          <declname>config</declname>
        </param>
        <briefdescription>
<para>This function initializes server of the Next DST Change service. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>config</parametername>
</parameternamelist>
<parameterdescription>
<para>Configuration structure for the NDCS.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para><ref kindref="member" refid="group__group__ble__common__api__definitions_1ga63f6be7f53f5ad7d82c394e4cdfa619e">cy_en_ble_api_result_t</ref> : Return value indicates whether the function succeeded or failed. The following are possible error codes.</para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Error Codes &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_SUCCESS &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The function completed successfully. &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_ERROR_INVALID_PARAMETER &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;On specifying NULL as input parameter. &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_ERROR_MEMORY_ALLOCATION_FAILED &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Buffer overflow in the registration callback. &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="89" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.c" bodystart="70" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.h" line="97" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ble__service__api___n_d_c_s__server__client_1gaff580055e76cf123f95fc6f007ac3963" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__ble__common__api__definitions_1ga63f6be7f53f5ad7d82c394e4cdfa619e">cy_en_ble_api_result_t</ref></type>
        <definition>cy_en_ble_api_result_t Cy_BLE_NDCSC_Init</definition>
        <argsstring>(const cy_stc_ble_ndcsc_config_t *config)</argsstring>
        <name>Cy_BLE_NDCSC_Init</name>
        <param>
          <type>const <ref kindref="compound" refid="structcy__stc__ble__ndcsc__config__t">cy_stc_ble_ndcsc_config_t</ref> *</type>
          <declname>config</declname>
        </param>
        <briefdescription>
<para>This function initializes client of the Next DST Change service. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>config</parametername>
</parameternamelist>
<parameterdescription>
<para>Configuration structure for the NDCS.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para><ref kindref="member" refid="group__group__ble__common__api__definitions_1ga63f6be7f53f5ad7d82c394e4cdfa619e">cy_en_ble_api_result_t</ref> : Return value indicates whether the function succeeded or failed. The following are possible error codes.</para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Error Codes &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_SUCCESS &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The function completed successfully. &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_ERROR_INVALID_PARAMETER &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;On specifying NULL as input parameter. &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_ERROR_MEMORY_ALLOCATION_FAILED &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Buffer overflow in the registration callback. &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="156" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.c" bodystart="111" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.h" line="98" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ble__service__api___n_d_c_s__server__client_1ga43c8b30c989aad571c87eba43b042afb" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void Cy_BLE_NDCS_RegisterAttrCallback</definition>
        <argsstring>(cy_ble_callback_t callbackFunc)</argsstring>
        <name>Cy_BLE_NDCS_RegisterAttrCallback</name>
        <param>
          <type><ref kindref="member" refid="group__group__ble__common__api__gap__definitions_1ga61c94db1ed82ed7113ce6aaecb5fead8">cy_ble_callback_t</ref></type>
          <declname>callbackFunc</declname>
        </param>
        <briefdescription>
<para>Registers a callback function for service-specific attribute operations. </para>        </briefdescription>
        <detaileddescription>
<para>Service-specific Write Requests from the peer device will not be handled with an unregistered callback function.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>callbackFunc</parametername>
</parameternamelist>
<parameterdescription>
<para>An application layer event callback function to receive events from the PSoC 6 BLE Middleware. The definition of <ref kindref="member" refid="group__group__ble__common__api__gap__definitions_1ga61c94db1ed82ed7113ce6aaecb5fead8">cy_ble_callback_t</ref> for NDCS service is:<linebreak />
 typedef void (* cy_ble_callback_t) (uint32_t eventCode, void *eventParam), where:<itemizedlist>
<listitem><para>eventCode: Indicates the event that triggered this callback (e.g. <ref kindref="member" refid="group__group__ble__service__api__events_1ggada4b6b6d080ad4380e3a2e3cab4f2d51a4da24b3fec8764010178e96de9439cb2">CY_BLE_EVT_NDCSC_READ_CHAR_RESPONSE</ref>).</para></listitem><listitem><para>eventParam: Contains the parameters corresponding to the current event; (e.g. pointer to <ref kindref="compound" refid="structcy__stc__ble__ndcs__char__value__t">cy_stc_ble_ndcs_char_value_t</ref> structure that contains details of the characteristic for which the notification enabled event was triggered). </para></listitem></itemizedlist>
</para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="183" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.c" bodystart="180" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.h" line="99" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ble__service__api___n_d_c_s__server_1gaaf393b2f01f05c7512145cb77cb61a64" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__ble__common__api__definitions_1ga63f6be7f53f5ad7d82c394e4cdfa619e">cy_en_ble_api_result_t</ref></type>
        <definition>cy_en_ble_api_result_t Cy_BLE_NDCSS_SetCharacteristicValue</definition>
        <argsstring>(cy_en_ble_ndcs_char_index_t charIndex, uint8_t attrSize, uint8_t *attrValue)</argsstring>
        <name>Cy_BLE_NDCSS_SetCharacteristicValue</name>
        <param>
          <type><ref kindref="member" refid="group__group__ble__service__api___n_d_c_s__definitions_1ga45eb82d743c04984f5db34e967541862">cy_en_ble_ndcs_char_index_t</ref></type>
          <declname>charIndex</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>attrSize</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>attrValue</declname>
        </param>
        <briefdescription>
<para>Sets characteristic value of the Next DST Change service, which is identified by charIndex in the local database. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>charIndex</parametername>
</parameternamelist>
<parameterdescription>
<para>The index of a service characteristic of type cy_en_ble_ndcs_char_index_t. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>attrSize</parametername>
</parameternamelist>
<parameterdescription>
<para>The size of the characteristic value attribute. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>attrValue</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the characteristic value data that should be stored to the GATT database.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>A return value of type <ref kindref="member" refid="group__group__ble__common__api__definitions_1ga63f6be7f53f5ad7d82c394e4cdfa619e">cy_en_ble_api_result_t</ref>.</para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Error Codes &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_SUCCESS &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The request is handled successfully. &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_ERROR_INVALID_PARAMETER &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Validation of the input parameters failed. &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="233" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.c" bodystart="206" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.h" line="107" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ble__service__api___n_d_c_s__server_1ga9f130cd577a81b17d3e706ca1efd48ad" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__ble__common__api__definitions_1ga63f6be7f53f5ad7d82c394e4cdfa619e">cy_en_ble_api_result_t</ref></type>
        <definition>cy_en_ble_api_result_t Cy_BLE_NDCSS_GetCharacteristicValue</definition>
        <argsstring>(cy_en_ble_ndcs_char_index_t charIndex, uint8_t attrSize, uint8_t *attrValue)</argsstring>
        <name>Cy_BLE_NDCSS_GetCharacteristicValue</name>
        <param>
          <type><ref kindref="member" refid="group__group__ble__service__api___n_d_c_s__definitions_1ga45eb82d743c04984f5db34e967541862">cy_en_ble_ndcs_char_index_t</ref></type>
          <declname>charIndex</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>attrSize</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>attrValue</declname>
        </param>
        <briefdescription>
<para>Gets a characteristic value of the Next DST Change service, which is identified by charIndex. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>charIndex</parametername>
</parameternamelist>
<parameterdescription>
<para>The index of a service characteristic of type cy_en_ble_ndcs_char_index_t. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>attrSize</parametername>
</parameternamelist>
<parameterdescription>
<para>The size of the characteristic value attribute.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>attrValue</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the location where characteristic value data should be stored.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>A return value of type <ref kindref="member" refid="group__group__ble__common__api__definitions_1ga63f6be7f53f5ad7d82c394e4cdfa619e">cy_en_ble_api_result_t</ref>.</para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Error Codes &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_SUCCESS &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The request is handled successfully. &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_ERROR_INVALID_PARAMETER &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Validation of the input parameters failed. &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="284" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.c" bodystart="259" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.h" line="110" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ble__service__api___n_d_c_s__client_1gadf7bdebe3ce113545e88f40972be02bc" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__ble__common__api__definitions_1ga63f6be7f53f5ad7d82c394e4cdfa619e">cy_en_ble_api_result_t</ref></type>
        <definition>cy_en_ble_api_result_t Cy_BLE_NDCSC_GetCharacteristicValue</definition>
        <argsstring>(cy_stc_ble_conn_handle_t connHandle, cy_en_ble_ndcs_char_index_t charIndex)</argsstring>
        <name>Cy_BLE_NDCSC_GetCharacteristicValue</name>
        <param>
          <type><ref kindref="compound" refid="structcy__stc__ble__conn__handle__t">cy_stc_ble_conn_handle_t</ref></type>
          <declname>connHandle</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__ble__service__api___n_d_c_s__definitions_1ga45eb82d743c04984f5db34e967541862">cy_en_ble_ndcs_char_index_t</ref></type>
          <declname>charIndex</declname>
        </param>
        <briefdescription>
<para>Sends a request to peer device to set characteristic value of the Next DST Change service, which is identified by charIndex. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>connHandle</parametername>
</parameternamelist>
<parameterdescription>
<para>The connection handle. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>charIndex</parametername>
</parameternamelist>
<parameterdescription>
<para>The index of a service characteristic.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>A return value of type <ref kindref="member" refid="group__group__ble__common__api__definitions_1ga63f6be7f53f5ad7d82c394e4cdfa619e">cy_en_ble_api_result_t</ref>.</para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Error Codes &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_SUCCESS &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;the request was sent successfully. &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_ERROR_INVALID_STATE &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;connection with the client is not established. &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_ERROR_INVALID_PARAMETER &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;validation of the input parameters failed. &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_ERROR_MEMORY_ALLOCATION_FAILED &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Memory allocation failed. &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_ERROR_INVALID_OPERATION &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Operation is invalid for this characteristic. &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim><simplesect kind="par"><title>Events</title><para>In case of successful execution (return value = <ref kindref="member" refid="group__group__ble__common__api__definitions_1gga63f6be7f53f5ad7d82c394e4cdfa619ea26e476ee364252903ce212deeb6ec064">CY_BLE_SUCCESS</ref>) the following events can appear: <linebreak />
 If the NDCS service-specific callback is registered (with <ref kindref="member" refid="group__group__ble__service__api___n_d_c_s__server__client_1ga43c8b30c989aad571c87eba43b042afb">Cy_BLE_NDCS_RegisterAttrCallback</ref>):<itemizedlist>
<listitem><para><ref kindref="member" refid="group__group__ble__service__api__events_1ggada4b6b6d080ad4380e3a2e3cab4f2d51a4da24b3fec8764010178e96de9439cb2">CY_BLE_EVT_NDCSC_READ_CHAR_RESPONSE</ref> - In case if the requested attribute is successfully read on the peer device, the details (charIndex , value, etc.) are provided with event parameter structure of type <ref kindref="compound" refid="structcy__stc__ble__ndcs__char__value__t">cy_stc_ble_ndcs_char_value_t</ref>.</para></listitem></itemizedlist>
Otherwise (if the NDCS service-specific callback is not registered):<itemizedlist>
<listitem><para><ref kindref="member" refid="group__group__ble__common__api__events_1gga7c1ef7e6d246e0f3eb6c883e23d82b86a9f66de88a47e0eb5cd2026421ffcea24">CY_BLE_EVT_GATTC_READ_RSP</ref> - In case if the requested attribute is successfully read on the peer device, the details (handle, value, etc.) are provided with event parameters structure (<ref kindref="compound" refid="structcy__stc__ble__gattc__read__rsp__param__t">cy_stc_ble_gattc_read_rsp_param_t</ref>).</para></listitem><listitem><para><ref kindref="member" refid="group__group__ble__common__api__events_1gga7c1ef7e6d246e0f3eb6c883e23d82b86a89dd75cdee5a4cf9131a12ad37363fd3">CY_BLE_EVT_GATTC_ERROR_RSP</ref> - In case if an error occurred with the requested attribute on the peer device, the details are provided with event parameters structure (<ref kindref="compound" refid="structcy__stc__ble__gatt__err__param__t">cy_stc_ble_gatt_err_param_t</ref>). </para></listitem></itemizedlist>
</para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="476" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.c" bodystart="442" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.h" line="120" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>Contains the function prototypes and constants for Next DST Change service. </para>    </briefdescription>
    <detaileddescription>
<para><simplesect kind="version"><para>3.50</para></simplesect>
<simplesect kind="copyright"><para>Copyright 2017-2020, Cypress Semiconductor Corporation. All rights reserved. You may use this file only in accordance with the license, terms, conditions, disclaimers, and limitations in the end user license agreement accompanying the software package with which this file was provided. </para></simplesect>
</para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="17"><highlight class="preprocessor">#ifndef<sp />CY_BLE_NDCS_H</highlight><highlight class="normal" /></codeline>
<codeline lineno="18"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_BLE_NDCS_H</highlight><highlight class="normal" /></codeline>
<codeline lineno="19"><highlight class="normal" /></codeline>
<codeline lineno="20"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_ble.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="21"><highlight class="normal" /></codeline>
<codeline lineno="22"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(CY_IP_MXBLESS)</highlight><highlight class="normal" /></codeline>
<codeline lineno="23"><highlight class="normal" /></codeline>
<codeline lineno="24"><highlight class="normal" /><highlight class="comment">/*<sp />C<sp />binding<sp />of<sp />definitions<sp />if<sp />building<sp />with<sp />C++<sp />compiler<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="25"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />__cplusplus</highlight><highlight class="normal" /></codeline>
<codeline lineno="26"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="27"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />__cplusplus<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="28"><highlight class="normal" /></codeline>
<codeline lineno="29"><highlight class="normal" /></codeline>
<codeline lineno="30"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="31"><highlight class="comment">*<sp />Data<sp />Types</highlight></codeline>
<codeline lineno="32"><highlight class="comment">*******************************************************************************/</highlight></codeline>
<codeline lineno="39"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">enum</highlight><highlight class="normal" /></codeline>
<codeline lineno="40"><highlight class="normal">{</highlight></codeline>
<codeline lineno="41"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__service__api___n_d_c_s__definitions_1gga45eb82d743c04984f5db34e967541862a2e0f3f530c62ea801c2faccecfbe7999">CY_BLE_NDCS_TIME_WITH_DST</ref>,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="42"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__service__api___n_d_c_s__definitions_1gga45eb82d743c04984f5db34e967541862a72ef1aa6d2418640c05122448829b333">CY_BLE_NDCS_CHAR_COUNT</ref><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="43"><highlight class="normal">}<sp /><ref kindref="member" refid="group__group__ble__service__api___n_d_c_s__definitions_1ga45eb82d743c04984f5db34e967541862">cy_en_ble_ndcs_char_index_t</ref>;</highlight></codeline>
<codeline lineno="44"><highlight class="normal" /></codeline>
<codeline lineno="46" refid="structcy__stc__ble__ndcs__char__value__t" refkind="compound"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal" /></codeline>
<codeline lineno="47"><highlight class="normal">{</highlight></codeline>
<codeline lineno="48"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__ble__conn__handle__t">cy_stc_ble_conn_handle_t</ref><sp /><sp /><sp /><sp />connHandle;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="49"><highlight class="normal"><sp /><sp /><sp /><sp />cy_en_ble_ndcs_char_index_t<sp />charIndex;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="50"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__ble__gatt__value__t">cy_stc_ble_gatt_value_t</ref><sp /><sp /><sp /><sp /><sp />*value;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="51"><highlight class="normal">}<sp /><ref kindref="compound" refid="structcy__stc__ble__ndcs__char__value__t">cy_stc_ble_ndcs_char_value_t</ref>;</highlight></codeline>
<codeline lineno="52"><highlight class="normal" /></codeline>
<codeline lineno="54" refid="structcy__stc__ble__ndcss__t" refkind="compound"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal" /></codeline>
<codeline lineno="55"><highlight class="normal">{</highlight></codeline>
<codeline lineno="56"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__gatt__definitions_1ga7609ec9fd5973eadda6b98e8dfbda580">cy_ble_gatt_db_attr_handle_t</ref><sp />serviceHandle;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="57"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__gatt__definitions_1ga7609ec9fd5973eadda6b98e8dfbda580">cy_ble_gatt_db_attr_handle_t</ref><sp />timeWithDst;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="58"><highlight class="normal">}<sp /><ref kindref="compound" refid="structcy__stc__ble__ndcss__t">cy_stc_ble_ndcss_t</ref>;</highlight></codeline>
<codeline lineno="59"><highlight class="normal" /></codeline>
<codeline lineno="61" refid="structcy__stc__ble__ndcsc__t" refkind="compound"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal" /></codeline>
<codeline lineno="62"><highlight class="normal">{</highlight></codeline>
<codeline lineno="64"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__ble__srvr__char__info__t">cy_stc_ble_srvr_char_info_t</ref><sp />charInfo[<ref kindref="member" refid="group__group__ble__service__api___n_d_c_s__definitions_1gga45eb82d743c04984f5db34e967541862a72ef1aa6d2418640c05122448829b333">CY_BLE_NDCS_CHAR_COUNT</ref>];</highlight></codeline>
<codeline lineno="65"><highlight class="normal">}<sp /><ref kindref="compound" refid="structcy__stc__ble__ndcsc__t">cy_stc_ble_ndcsc_t</ref>;</highlight></codeline>
<codeline lineno="66"><highlight class="normal" /></codeline>
<codeline lineno="68" refid="structcy__stc__ble__ndcss__config__t" refkind="compound"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal" /></codeline>
<codeline lineno="69"><highlight class="normal">{</highlight></codeline>
<codeline lineno="71"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__ble__ndcss__t">cy_stc_ble_ndcss_t</ref><sp />*attrInfo;</highlight></codeline>
<codeline lineno="72"><highlight class="normal" /></codeline>
<codeline lineno="73"><highlight class="normal">}<sp /><ref kindref="compound" refid="structcy__stc__ble__ndcss__config__t">cy_stc_ble_ndcss_config_t</ref>;</highlight></codeline>
<codeline lineno="74"><highlight class="normal" /></codeline>
<codeline lineno="76" refid="structcy__stc__ble__ndcsc__config__t" refkind="compound"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal" /></codeline>
<codeline lineno="77"><highlight class="normal">{</highlight></codeline>
<codeline lineno="79"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__ble__ndcsc__t">cy_stc_ble_ndcsc_t</ref><sp />*attrInfo;</highlight></codeline>
<codeline lineno="80"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="82"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />serviceDiscIdx;</highlight></codeline>
<codeline lineno="83"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="84"><highlight class="normal">}<sp /><ref kindref="compound" refid="structcy__stc__ble__ndcsc__config__t">cy_stc_ble_ndcsc_config_t</ref>;</highlight></codeline>
<codeline lineno="85"><highlight class="normal" /></codeline>
<codeline lineno="89"><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="90"><highlight class="comment">*<sp />Function<sp />Prototypes</highlight></codeline>
<codeline lineno="91"><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="92"><highlight class="normal" /></codeline>
<codeline lineno="97"><highlight class="normal"><ref kindref="member" refid="group__group__ble__common__api__definitions_1ga63f6be7f53f5ad7d82c394e4cdfa619e">cy_en_ble_api_result_t</ref><sp /><ref kindref="member" refid="group__group__ble__service__api___n_d_c_s__server__client_1ga88bcea3051b51b6ce572807f1d90605d">Cy_BLE_NDCSS_Init</ref>(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__ble__ndcss__config__t">cy_stc_ble_ndcss_config_t</ref><sp />*config);</highlight></codeline>
<codeline lineno="98"><highlight class="normal"><ref kindref="member" refid="group__group__ble__common__api__definitions_1ga63f6be7f53f5ad7d82c394e4cdfa619e">cy_en_ble_api_result_t</ref><sp /><ref kindref="member" refid="group__group__ble__service__api___n_d_c_s__server__client_1gaff580055e76cf123f95fc6f007ac3963">Cy_BLE_NDCSC_Init</ref>(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__ble__ndcsc__config__t">cy_stc_ble_ndcsc_config_t</ref><sp />*config);</highlight></codeline>
<codeline lineno="99"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ble__service__api___n_d_c_s__server__client_1ga43c8b30c989aad571c87eba43b042afb">Cy_BLE_NDCS_RegisterAttrCallback</ref>(<ref kindref="member" refid="group__group__ble__common__api__gap__definitions_1ga61c94db1ed82ed7113ce6aaecb5fead8">cy_ble_callback_t</ref><sp />callbackFunc);</highlight></codeline>
<codeline lineno="107"><highlight class="normal"><ref kindref="member" refid="group__group__ble__common__api__definitions_1ga63f6be7f53f5ad7d82c394e4cdfa619e">cy_en_ble_api_result_t</ref><sp /><ref kindref="member" refid="group__group__ble__service__api___n_d_c_s__server_1gaaf393b2f01f05c7512145cb77cb61a64">Cy_BLE_NDCSS_SetCharacteristicValue</ref>(cy_en_ble_ndcs_char_index_t<sp />charIndex,<sp />uint8_t<sp />attrSize,</highlight></codeline>
<codeline lineno="108"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint8_t<sp />*attrValue);</highlight></codeline>
<codeline lineno="109"><highlight class="normal" /></codeline>
<codeline lineno="110"><highlight class="normal"><ref kindref="member" refid="group__group__ble__common__api__definitions_1ga63f6be7f53f5ad7d82c394e4cdfa619e">cy_en_ble_api_result_t</ref><sp /><ref kindref="member" refid="group__group__ble__service__api___n_d_c_s__server_1ga9f130cd577a81b17d3e706ca1efd48ad">Cy_BLE_NDCSS_GetCharacteristicValue</ref>(cy_en_ble_ndcs_char_index_t<sp />charIndex,<sp />uint8_t<sp />attrSize,</highlight></codeline>
<codeline lineno="111"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint8_t<sp />*attrValue);</highlight></codeline>
<codeline lineno="112"><highlight class="normal" /></codeline>
<codeline lineno="120"><highlight class="normal"><ref kindref="member" refid="group__group__ble__common__api__definitions_1ga63f6be7f53f5ad7d82c394e4cdfa619e">cy_en_ble_api_result_t</ref><sp /><ref kindref="member" refid="group__group__ble__service__api___n_d_c_s__client_1gadf7bdebe3ce113545e88f40972be02bc">Cy_BLE_NDCSC_GetCharacteristicValue</ref>(<ref kindref="compound" refid="structcy__stc__ble__conn__handle__t">cy_stc_ble_conn_handle_t</ref><sp />connHandle,</highlight></codeline>
<codeline lineno="121"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_en_ble_ndcs_char_index_t<sp />charIndex);</highlight></codeline>
<codeline lineno="122"><highlight class="normal" /></codeline>
<codeline lineno="125"><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="126"><highlight class="comment">*<sp />External<sp />Data<sp />references</highlight></codeline>
<codeline lineno="127"><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="128"><highlight class="normal" /></codeline>
<codeline lineno="129"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__ble__ndcss__config__t">cy_stc_ble_ndcss_config_t</ref><sp />*cy_ble_ndcssConfigPtr;</highlight></codeline>
<codeline lineno="130"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__ble__ndcsc__config__t">cy_stc_ble_ndcsc_config_t</ref><sp />*cy_ble_ndcscConfigPtr;</highlight></codeline>
<codeline lineno="131"><highlight class="normal" /></codeline>
<codeline lineno="132"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />__cplusplus</highlight><highlight class="normal" /></codeline>
<codeline lineno="133"><highlight class="normal">}</highlight></codeline>
<codeline lineno="134"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />__cplusplus<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="135"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CY_IP_MXBLESS<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="136"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CY_BLE_NDCS_H<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="137"><highlight class="normal" /></codeline>
<codeline lineno="138"><highlight class="normal" /><highlight class="comment">/*<sp />[]<sp />END<sp />OF<sp />FILE<sp />*/</highlight><highlight class="normal" /></codeline>
    </programlisting>
    <location file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-bless/cy_ble_ndcs.h" />
  </compounddef>
</doxygen>